Bug 246133 - Include HTML+Java libraries in NetBeans Platform
Include HTML+Java libraries in NetBeans Platform
Status: RESOLVED FIXED
Product: platform
Classification: Unclassified
Component: -- Other --
8.1
PC All
: P1 (vote)
: 8.1
Assigned To: Jaroslav Tulach
issues@platform
: API_REVIEW
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2014-07-30 13:23 UTC by Jaroslav Tulach
Modified: 2014-12-05 04:17 UTC (History)
5 users (show)

See Also:
Issue Type: TASK
:


Attachments
GLProvider written for iOS against html4j rev. e5723aecdaff (6.27 KB, text/x-java)
2014-09-01 16:00 UTC, Jaroslav Tulach
Details
Sample module using @HTMLDialog annotation (15.25 KB, patch)
2014-09-04 16:23 UTC, Jaroslav Tulach
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Jaroslav Tulach 2014-07-30 13:23:20 UTC
The wizard created as
http://wiki.apidesign.org/wiki/DukeScriptInNetBeans
and the minesweeper game
http://plugins.netbeans.org/plugin/53864
https://play.google.com/store/apps/details?id=org.apidesign.demo.minesweeper
show that HTML/Java APIs are useful for development of portable UIs that can run almost on any device.

To make it easier for users of NetBeans platform to access this functionality, include http://bits.netbeans.org/html+java/ libraries in NetBeans Platform.
Comment 1 Jaroslav Tulach 2014-07-31 15:02:13 UTC
Here is the patch that I'd like to review:
http://hg.netbeans.org/ergonomics/rev/c81e25efd997
It adds bunch of new OSGi JARs into the platform and one specific NetBeans module that binds it all together. Right now the JARs are downloaded from Maven repository - that may or may not stay (we can stick to our classical binaries system). Right now the only (NetBeans specific) API allows creation of a HTML based TopComponent. I am considering to add a way to show HTML dialog too.
Comment 2 Jaroslav Tulach 2014-08-21 10:07:31 UTC
I'd like to have an inception review on Tuesday Aug 26, 2014, 11am. Prague meets in Giza. Tomáš Hůrka, Tomáš Zezula, Jaroslav Havlín and (hopefully) Petr Hejl will be the voting reviewers.

Feel free to add your questions here or to associated wiki page:
http://wiki.netbeans.org/Html4Java

After some discussions I'd like to explain the main goal of the project: Provide standard way to write NetBeans modules with nice, slick UI, but while avoiding dependency on Swing or JavaFX!
Comment 3 Jaroslav Tulach 2014-08-26 10:00:25 UTC
Approved for development with following comments:
http://wiki.netbeans.org/wiki/index.php?title=Html4Java&diff=66991&oldid=66986
Comment 4 Jaroslav Tulach 2014-08-27 16:49:16 UTC
One of the technical change requests was to create SPI for Geolocation API. Here it is: http://hg.netbeans.org/html4j/diff/5ed774012807/geo/src/main/java/org/netbeans/html/geo/spi/GLProvider.java
Please check if it suites your needs. I verified it works in bck2brwsr.
Comment 5 Jaroslav Tulach 2014-09-01 16:00:20 UTC
Created attachment 148980 [details]
GLProvider written for iOS against html4j rev. e5723aecdaff
Comment 6 Jaroslav Tulach 2014-09-04 16:23:23 UTC
Created attachment 149040 [details]
Sample module using @HTMLDialog annotation

I think I am ready for final review on Tuesday Sep 9, 10.30. Prague meets in Babylon. 

The @HTMLDialog annotation looks solid. I still need to create @HTMLComponent annotation for embedding into Swing/FX UI and create API support wizards. But I should have that by Tuesday.

The repackaging of the SPI has turned into major disruption of downstream projects and they currently suffer from not having stable version with the new packages available. As such #1 thing I need is to get approval to release version 1.0 of the html4j API.
Comment 7 Jaroslav Tulach 2014-09-05 06:06:55 UTC
The Javadoc is available at http://deadlock.netbeans.org/job/prototypes-HtmlJava246133/javadoc/org-netbeans-api-html4j/
Comment 8 Jaroslav Tulach 2014-09-08 15:19:30 UTC
No comments so far? Let's start preparing a release, then!
Comment 9 Jaroslav Tulach 2014-09-09 19:49:11 UTC
Merging into default branch:
http://hg.netbeans.org/ergonomics/rev/f4f985ddf487
Comment 10 Quality Engineering 2014-09-11 02:44:05 UTC
Integrated into 'main-silver', will be available in build *201409110001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)

Changeset: http://hg.netbeans.org/main-silver/rev/1b8d6ed37745
User: Jaroslav Tulach <jtulach@netbeans.org>
Log: Per technical change request of reviewers in #246133, renaming the special HTML/Java bindings for NetBeans module to org.netbeans.api.html4j
Comment 11 Jaroslav Tulach 2014-09-12 15:37:23 UTC
Reviewers I know we discussed the name of the module. Right now it is

org.netbeans.api.html4j

today I was updating Javadoc and realized that relatively good name could be:

org.netbeans.api.htmlui

- e.g. "HTML UI NetBeans". Please think about it, have a vote and in case you decide to change the name, let me know I will update the Hg repository. Thanks.
Comment 12 Jaroslav Havlin 2014-09-15 13:44:03 UTC
(In reply to Jaroslav Tulach from comment #11)
> org.netbeans.api.htmlui
> - e.g. "HTML UI NetBeans". Please think about it, have a vote and in case
> you decide to change the name, let me know I will update the Hg repository.
This name seems more descriptive to me, so I would vote for this change.
Comment 13 Tomas Zezula 2014-09-15 15:28:46 UTC
The htmlui sounds good to me.
Comment 14 Jaroslav Tulach 2014-12-02 11:23:12 UTC
Switching the module name to org.netbeans.api.htmlui as of ergonomics#6fa842ff4067
Comment 15 Quality Engineering 2014-12-05 04:17:15 UTC
Integrated into 'main-silver', will be available in build *201412050001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)

Changeset: http://hg.netbeans.org/main-silver/rev/6fa842ff4067
User: Jaroslav Tulach <jtulach@netbeans.org>
Log: #246133: As a final request renaming the module to api.htmlui


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo